; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: CPD9.PAS
 
.nolist
.INCLUDE "m2560def.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x3E80 ; WORD
.equ        UBRR_VAL  =  0x05 ; BYTE
.equ        WAITKON  =  0x0010 ; WORD
.equ        WAITKON2  =  0x02D0 ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
CLK_COUNTER:   ; Byte
.byte     1
RAM_READ_AKTIV:   ; Boolean
.byte     1
BYTE_HEX_STRING:   ; String(2)
.byte     1     ; STRING-Laenge
.byte     2
BYTE_DEZ_STRING:   ; String(3)
.byte     1     ; STRING-Laenge
.byte     3
WORD_HEX_STRING:   ; String(4)
.byte     1     ; STRING-Laenge
.byte     4
DWORD_HEX_STRING:   ; String(8)
.byte     1     ; STRING-Laenge
.byte     8
 
RAM_ARRAY:
.byte     101
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        LDI   ZL,byte3(RESET)
        OUT   EIND,ZL
        LDI   ZL,low(RESET)
        LDI   ZH,high(RESET)
        EIJMP
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        LDI   ZL,byte3(BYTEPOSTOORMASKE)
        OUT   EIND,ZL
        LDI   ZL,low(BYTEPOSTOORMASKE)
        LDI   ZH,high(BYTEPOSTOORMASKE)
        EICALL
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        LDI   ZL,byte3(BYTEPOSTOORMASKE)
        OUT   EIND,ZL
        LDI   ZL,low(BYTEPOSTOORMASKE)
        LDI   ZH,high(BYTEPOSTOORMASKE)
        EICALL
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        LDI   ZL,byte3(BYTEPOSTOANDMASKE)
        OUT   EIND,ZL
        LDI   ZL,low(BYTEPOSTOANDMASKE)
        LDI   ZH,high(BYTEPOSTOANDMASKE)
        EICALL
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (NEGATION_BYTE)
NEGATION_BYTE:
 
; ASM
COM    R0
 
 
; RESULT Byte-Variable - FUNCTION (NEGATION_BYTE)
        MOV        R1, R0
 
; Ende Byte - FUNCTION (NEGATION_BYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (NEGATION_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (WAITKON2)
        LDI        R16, LOW(0x02D0)
        LDI        R17, HIGH(0x02D0)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOHEXSTRING)
BYTETOHEXSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOHEXSTRING)
        RET
 
; PROCEDURE - Anfang (BYTETODEZSTRING)
BYTETODEZSTRING:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; WHILE DO ...
M_WHILE_065:
 
; WHILE - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x64)
        LDI        R18, 0x64
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_068
        CLR        R16
        RJMP       M_VERGL_069
M_VERGL_068:
        SER        R16
M_VERGL_069:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_066
        RJMP       M_WHILE_067
M_WHILE_066:
 
; WHILE DO ...
        RJMP       M_WHILE_065
M_WHILE_067:
 
; PROCEDURE - Ende (BYTETODEZSTRING)
        RET
 
; FUNCTION - Anfang (HEXSTRINGTOBYTE)
HEXSTRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_073
        CLR        R16
        RJMP       M_VERGL_074
M_VERGL_073:
        SER        R16
M_VERGL_074:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_070
        RJMP       M_IF_071
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_071:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_078
        CLR        R16
        RJMP       M_VERGL_079
M_VERGL_078:
        SER        R16
M_VERGL_079:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_075
        RJMP       M_IF_076
M_IF_075:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_076:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (HEXSTRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (HEXSTRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (HEXSTRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (WORDTOHEXSTRING)
WORDTOHEXSTRING:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT_WORD)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_LOW)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT_WORD)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_HIGH)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_HIGH) retten
        MOV        R19, R3
 
; lokalen Parameter (BYTE_HIGH) an Prozedur (BYTETOHEXSTRING)
        MOV        R0, R19
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        LDI   ZL,byte3(BYTETOHEXSTRING)
        OUT   EIND,ZL
        LDI   ZL,low(BYTETOHEXSTRING)
        LDI   ZH,high(BYTETOHEXSTRING)
        EICALL
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOHEXSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WORD_HEX_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_080
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_080:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_082
M_PRG_CONST_STRING_081:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_081
M_PRG_CONST_STRING_082:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_084
        MOV        R16, R17
M_PRG_CONST_STRING_083:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_083
M_PRG_CONST_STRING_084:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_LOW) retten
        MOV        R18, R2
 
; lokalen Parameter (BYTE_LOW) an Prozedur (BYTETOHEXSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        LDI   ZL,byte3(BYTETOHEXSTRING)
        OUT   EIND,ZL
        LDI   ZL,low(BYTETOHEXSTRING)
        LDI   ZH,high(BYTETOHEXSTRING)
        EICALL
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOHEXSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WORD_HEX_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_085
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_085:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_087
M_PRG_CONST_STRING_086:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_086
M_PRG_CONST_STRING_087:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_088
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_088:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_090
M_PRG_CONST_STRING_089:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_089
M_PRG_CONST_STRING_090:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_092
        MOV        R16, R17
M_PRG_CONST_STRING_091:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_091
M_PRG_CONST_STRING_092:
        ST         -Z, R17
 
; PROCEDURE - Ende (WORDTOHEXSTRING)
        RET
 
; FUNCTION - Anfang (HEXSTRINGTOWORD)
HEXSTRINGTOWORD:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_093
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_093:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_095
        MOV        R16, R17
M_PRG_CONST_STRING_094:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_094
M_PRG_CONST_STRING_095:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_096
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_096:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_098
M_PRG_CONST_STRING_097:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_097
M_PRG_CONST_STRING_098:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_099
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_099:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0101
        MOV        R16, R17
M_PRG_CONST_STRING_0100:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0100
M_PRG_CONST_STRING_0101:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (HEXSTRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (HEXSTRINGTOBYTE)
        LDI   ZL,byte3(HEXSTRINGTOBYTE)
        OUT   EIND,ZL
        LDI   ZL,low(HEXSTRINGTOBYTE)
        LDI   ZH,high(HEXSTRINGTOBYTE)
        EICALL
 
; Retten der Parameter-Register fuer PROCEDURE (HEXSTRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        LDI   ZL,byte3(ASM_UP_MUL16)
        OUT   EIND,ZL
        LDI   ZL,low(ASM_UP_MUL16)
        LDI   ZH,high(ASM_UP_MUL16)
        EICALL
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0102
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0102:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0104
        MOV        R16, R17
M_PRG_CONST_STRING_0103:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0103
M_PRG_CONST_STRING_0104:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0105
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0105:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0107
M_PRG_CONST_STRING_0106:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0106
M_PRG_CONST_STRING_0107:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0108
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0108:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0110
        MOV        R16, R17
M_PRG_CONST_STRING_0109:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0109
M_PRG_CONST_STRING_0110:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (HEXSTRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (HEXSTRINGTOBYTE)
        LDI   ZL,byte3(HEXSTRINGTOBYTE)
        OUT   EIND,ZL
        LDI   ZL,low(HEXSTRINGTOBYTE)
        LDI   ZH,high(HEXSTRINGTOBYTE)
        EICALL
 
; Retten der Parameter-Register fuer PROCEDURE (HEXSTRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (S2W2)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; RESULT Word-Variable - FUNCTION (HEXSTRINGTOWORD)
        MOV        R0, R3
        MOV        R1, R4
 
; Ende Word - FUNCTION (HEXSTRINGTOWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; FUNCTION - Ende (HEXSTRINGTOWORD)
        RET
 
; PROCEDURE - Anfang (DWORDTOHEXSTRING)
DWORDTOHEXSTRING:
 
; Zuweisung Quelle - Ausdruck / DWLow(WERT_DWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_LOW)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / DWHigh(WERT_DWORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_HIGH)
        MOV        R6, R16
        MOV        R7, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_HIGH) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (WORD_HIGH) an Prozedur (WORDTOHEXSTRING)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf PROCEDURE (WORDTOHEXSTRING)
        LDI   ZL,byte3(WORDTOHEXSTRING)
        OUT   EIND,ZL
        LDI   ZL,low(WORDTOHEXSTRING)
        LDI   ZH,high(WORDTOHEXSTRING)
        EICALL
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOHEXSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (DWORD_HEX_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0111
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0111:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0113
M_PRG_CONST_STRING_0112:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0112
M_PRG_CONST_STRING_0113:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_HEX_STRING)
        LDI        ZH, HIGH(DWORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0115
        MOV        R16, R17
M_PRG_CONST_STRING_0114:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0114
M_PRG_CONST_STRING_0115:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_LOW) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (WORD_LOW) an Prozedur (WORDTOHEXSTRING)
        MOV        R0, R20
        MOV        R1, R21
 
; Aufruf PROCEDURE (WORDTOHEXSTRING)
        LDI   ZL,byte3(WORDTOHEXSTRING)
        OUT   EIND,ZL
        LDI   ZL,low(WORDTOHEXSTRING)
        LDI   ZH,high(WORDTOHEXSTRING)
        EICALL
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOHEXSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (DWORD_HEX_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(DWORD_HEX_STRING)
        LDI        ZH, HIGH(DWORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0116
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0116:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0118
M_PRG_CONST_STRING_0117:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0117
M_PRG_CONST_STRING_0118:
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0119
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0119:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0121
M_PRG_CONST_STRING_0120:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0120
M_PRG_CONST_STRING_0121:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_HEX_STRING)
        LDI        ZH, HIGH(DWORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0123
        MOV        R16, R17
M_PRG_CONST_STRING_0122:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0122
M_PRG_CONST_STRING_0123:
        ST         -Z, R17
 
; PROCEDURE - Ende (DWORDTOHEXSTRING)
        RET
 
; PROCEDURE - Anfang (INIT_RAM)
INIT_RAM:
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; VAR ARRAY Ziel Zeiger berechnen (RAM_ARRAY)
        LDI        ZL, LOW(RAM_ARRAY)
        LDI        ZH, HIGH(RAM_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR ARRAY-1D (RAM_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; VAR ARRAY Ziel Zeiger berechnen (RAM_ARRAY)
        LDI        ZL, LOW(RAM_ARRAY)
        LDI        ZH, HIGH(RAM_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x23)
        LDI        R16, 0x23
 
; Zuweisung Ziel /  VAR ARRAY-1D (RAM_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; VAR ARRAY Ziel Zeiger berechnen (RAM_ARRAY)
        LDI        ZL, LOW(RAM_ARRAY)
        LDI        ZH, HIGH(RAM_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC3)
        LDI        R16, 0xC3
 
; Zuweisung Ziel /  VAR ARRAY-1D (RAM_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0003)
        LDI        R16, LOW(0x0003)
        LDI        R17, HIGH(0x0003)
 
; VAR ARRAY Ziel Zeiger berechnen (RAM_ARRAY)
        LDI        ZL, LOW(RAM_ARRAY)
        LDI        ZH, HIGH(RAM_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR ARRAY-1D (RAM_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0004)
        LDI        R16, LOW(0x0004)
        LDI        R17, HIGH(0x0004)
 
; VAR ARRAY Ziel Zeiger berechnen (RAM_ARRAY)
        LDI        ZL, LOW(RAM_ARRAY)
        LDI        ZH, HIGH(RAM_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR ARRAY-1D (RAM_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; PROCEDURE - Ende (INIT_RAM)
        RET
 
; FUNCTION - Anfang (LESE_RAM)
LESE_RAM:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (PINK)
        LDS        R16, PINK
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESS_BYTE)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ADRESS_BYTE)
        MOV        R16, R2
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESS_WORD)
        MOV        R3, R16
        MOV        R4, R17
 
; SHL(ADRESS_WORD) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADRESS_WORD) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADRESS_WORD) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADRESS_WORD) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADRESS_WORD) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADRESS_WORD) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADRESS_WORD) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADRESS_WORD) - Word
        LSL        R3
        ROL        R4
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINF
        IN         R16, PINF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESS_BYTE)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ADRESS_BYTE)
        MOV        R16, R2
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESS_WORD_LOW)
        MOV        R5, R16
        MOV        R6, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESS_WORD)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (ADRESS_WORD_LOW)
        MOV        R18, R5
        MOV        R19, R6
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESS_WORD)
        MOV        R3, R16
        MOV        R4, R17
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ADRESS_WORD)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (RAM_ARRAY)
        LDI        ZL, LOW(RAM_ARRAY)
        LDI        ZH, HIGH(RAM_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATEN_BYTE)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (LESE_RAM)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (LESE_RAM)
        MOV        R16, R0
 
; FUNCTION - Ende (LESE_RAM)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRF)
        OUT        DDRF, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRK)
        STS        DDRK, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; SetBit(Z80_CLK_D)
        LDS        R16, DDRL
        SBR        R16, 0b00000001
        STS        DDRL, R16
 
; ClearBit(Z80_CLK_A)
        LDS        R16, PORTL
        CBR        R16, 0b00000001
        STS        PORTL, R16
 
; SetBit(Z80_RESET_D)
        LDS        R16, DDRL
        SBR        R16, 0b00000100
        STS        DDRL, R16
 
; SetBit(Z80_RESET_A)
        LDS        R16, PORTL
        SBR        R16, 0b00000100
        STS        PORTL, R16
 
; SetBit(Z80_WAIT_D)
        LDS        R16, DDRL
        SBR        R16, 0b00010000
        STS        DDRL, R16
 
; SetBit(Z80_WAIT_A)
        LDS        R16, PORTL
        SBR        R16, 0b00010000
        STS        PORTL, R16
 
; SetBit(Z80_NMI_D)
        LDS        R16, DDRL
        SBR        R16, 0b01000000
        STS        DDRL, R16
 
; SetBit(Z80_NMI_A)
        LDS        R16, PORTL
        SBR        R16, 0b01000000
        STS        PORTL, R16
 
; SetBit(Z80_INT_D)
        SBI        DDRG, 0
 
; SetBit(Z80_INT_A)
        SBI        PORTG, 0
 
; SetBit(Z80_BUSRQ_D)
        SBI        DDRG, 2
 
; SetBit(Z80_BUSRQ_A)
        SBI        PORTG, 2
 
; SetBit(RAM_WE_D)
        SBI        DDRD, 7
 
; SetBit(RAM_WE_A)
        SBI        PORTD, 7
 
; SetBit(RAM_RD_D)
        SBI        DDRG, 1
 
; SetBit(RAM_RD_A)
        SBI        PORTG, 1
 
; SetBit(RAM_CE_D)
        LDS        R16, DDRL
        SBR        R16, 0b10000000
        STS        DDRL, R16
 
; SetBit(RAM_CE_A)
        LDS        R16, PORTL
        SBR        R16, 0b10000000
        STS        PORTL, R16
 
; SetBit(LED_BL3_D)
        LDS        R16, DDRH
        SBR        R16, 0b01000000
        STS        DDRH, R16
 
; ClearBit(LED_BL3_A)
        LDS        R16, PORTH
        CBR        R16, 0b01000000
        STS        PORTH, R16
 
; SetBit(LED_BL4_D)
        SBI        DDRB, 4
 
; ClearBit(LED_BL4_A)
        CBI        PORTB, 4
 
; SetBit(LED_BL5_D)
        SBI        DDRB, 5
 
; ClearBit(LED_BL5_A)
        CBI        PORTB, 5
 
; SetBit(LED_BL6_D)
        SBI        DDRB, 6
 
; ClearBit(LED_BL6_A)
        CBI        PORTB, 6
 
; SetBit(LED_BL7_D)
        SBI        DDRB, 7
 
; ClearBit(LED_BL7_A)
        CBI        PORTB, 7
 
; ClearBit(TASTER_01_D)
        LDS        R16, DDRH
        CBR        R16, 0b00001000
        STS        DDRH, R16
 
; ClearBit(TASTER_02_D)
        LDS        R16, DDRH
        CBR        R16, 0b00010000
        STS        DDRH, R16
 
; ClearBit(TASTER_03_D)
        LDS        R16, DDRH
        CBR        R16, 0b00100000
        STS        DDRH, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; VAR ARRAY Ziel Zeiger berechnen (RAM_ARRAY)
        LDI        ZL, LOW(RAM_ARRAY)
        LDI        ZH, HIGH(RAM_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC3)
        LDI        R16, 0xC3
 
; Zuweisung Ziel /  VAR ARRAY-1D (RAM_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; VAR ARRAY Ziel Zeiger berechnen (RAM_ARRAY)
        LDI        ZL, LOW(RAM_ARRAY)
        LDI        ZH, HIGH(RAM_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR ARRAY-1D (RAM_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; VAR ARRAY Ziel Zeiger berechnen (RAM_ARRAY)
        LDI        ZL, LOW(RAM_ARRAY)
        LDI        ZH, HIGH(RAM_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR ARRAY-1D (RAM_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (RAM_READ_EINSCHALTEN)
RAM_READ_EINSCHALTEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (RAM_READ_AKTIV)
        STS        RAM_READ_AKTIV, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (RAM_READ_EINSCHALTEN)
        PUSH       R0
 
; Aufruf Funktion (LESE_RAM)
        LDI   ZL,byte3(LESE_RAM)
        OUT   EIND,ZL
        LDI   ZL,low(LESE_RAM)
        LDI   ZH,high(LESE_RAM)
        EICALL
 
; Retten der Parameter-Register fuer PROCEDURE (RAM_READ_EINSCHALTEN)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; PROCEDURE - Ende (RAM_READ_EINSCHALTEN)
        RET
 
; PROCEDURE - Anfang (RAM_READ_AUSSCHALTEN)
RAM_READ_AUSSCHALTEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (RAM_READ_AKTIV)
        STS        RAM_READ_AKTIV, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; PROCEDURE - Ende (RAM_READ_AUSSCHALTEN)
        RET
 
; PROCEDURE - Anfang (ABFRAGE_MREQ_RD)
ABFRAGE_MREQ_RD:
 
; IF THEN - Ausdruck /; BitLow(Z80_MREQ_E)
        IN         R16, PINC
        BST        R16, 1
        BRTC       M_VERGL_0127
        CLR        R16
        RJMP       M_VERGL_0128
M_VERGL_0127:
        SER        R16
M_VERGL_0128:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0124
        RJMP       M_IF_0125
M_IF_0124:
 
; IF THEN - Ausdruck /; BitLow(Z80_RD_E)
        IN         R16, PINC
        BST        R16, 3
        BRTC       M_VERGL_0132
        CLR        R16
        RJMP       M_VERGL_0133
M_VERGL_0132:
        SER        R16
M_VERGL_0133:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0129
        RJMP       M_IF_0130
M_IF_0129:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (RAM_READ_AKTIV)
        LDS        R16, RAM_READ_AKTIV
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0137
        CLR        R16
        RJMP       M_VERGL_0138
M_VERGL_0137:
        SER        R16
M_VERGL_0138:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0134
        RJMP       M_IF_0135
M_IF_0134:
 
; Aufruf PROCEDURE (RAM_READ_EINSCHALTEN)
        LDI   ZL,byte3(RAM_READ_EINSCHALTEN)
        OUT   EIND,ZL
        LDI   ZL,low(RAM_READ_EINSCHALTEN)
        LDI   ZH,high(RAM_READ_EINSCHALTEN)
        EICALL
 
; SetBit(LED_BL5_A)
        SBI        PORTB, 5
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; ClearBit(LED_BL5_A)
        CBI        PORTB, 5
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; SetBit(LED_BL5_A)
        SBI        PORTB, 5
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; ClearBit(LED_BL5_A)
        CBI        PORTB, 5
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; SetBit(LED_BL5_A)
        SBI        PORTB, 5
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; ClearBit(LED_BL5_A)
        CBI        PORTB, 5
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; SetBit(LED_BL5_A)
        SBI        PORTB, 5
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; ClearBit(LED_BL5_A)
        CBI        PORTB, 5
 
; IF_THEN - Ende
M_IF_0135:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0131
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0130:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (RAM_READ_AKTIV)
        LDS        R16, RAM_READ_AKTIV
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xFF)
        LDI        R18, 0xFF
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0142
        CLR        R16
        RJMP       M_VERGL_0143
M_VERGL_0142:
        SER        R16
M_VERGL_0143:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0139
        RJMP       M_IF_0140
M_IF_0139:
 
; Aufruf PROCEDURE (RAM_READ_AUSSCHALTEN)
        LDI   ZL,byte3(RAM_READ_AUSSCHALTEN)
        OUT   EIND,ZL
        LDI   ZL,low(RAM_READ_AUSSCHALTEN)
        LDI   ZH,high(RAM_READ_AUSSCHALTEN)
        EICALL
 
; IF_THEN - Ende
M_IF_0140:
 
; IF_THEN_ELSE - Ende
M_IF_0131:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0126
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0125:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (RAM_READ_AKTIV)
        LDS        R16, RAM_READ_AKTIV
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xFF)
        LDI        R18, 0xFF
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0147
        CLR        R16
        RJMP       M_VERGL_0148
M_VERGL_0147:
        SER        R16
M_VERGL_0148:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0144
        RJMP       M_IF_0145
M_IF_0144:
 
; Aufruf PROCEDURE (RAM_READ_AUSSCHALTEN)
        LDI   ZL,byte3(RAM_READ_AUSSCHALTEN)
        OUT   EIND,ZL
        LDI   ZL,low(RAM_READ_AUSSCHALTEN)
        LDI   ZH,high(RAM_READ_AUSSCHALTEN)
        EICALL
 
; IF_THEN - Ende
M_IF_0145:
 
; IF_THEN_ELSE - Ende
M_IF_0126:
 
; PROCEDURE - Ende (ABFRAGE_MREQ_RD)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Aufruf PROCEDURE (INITPORTS)
        LDI   ZL,byte3(INITPORTS)
        OUT   EIND,ZL
        LDI   ZL,low(INITPORTS)
        LDI   ZH,high(INITPORTS)
        EICALL
 
; Aufruf PROCEDURE (INIT_RAM)
        LDI   ZL,byte3(INIT_RAM)
        OUT   EIND,ZL
        LDI   ZL,low(INIT_RAM)
        LDI   ZH,high(INIT_RAM)
        EICALL
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; ClearBit(Z80_RESET_A)
        LDS        R16, PORTL
        CBR        R16, 0b00000100
        STS        PORTL, R16
 
; SetBit(LED_BL6_A)
        SBI        PORTB, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (CLK_COUNTER)
        STS        CLK_COUNTER, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x64)
        LDI        R16, 0x64
 
; FOR TO DO - Laden des Byte-Zaehlwertes
        LDS        R17, CLK_COUNTER
 
; FOR TO DO - Vergleichswert Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0149:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0150
        RJMP       M_FTD_0151
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0150:
 
; ClearBit(LED_BL6_A)
        CBI        PORTB, 6
 
; ClearBit(Z80_CLK_A)
        LDS        R16, PORTL
        CBR        R16, 0b00000001
        STS        PORTL, R16
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0001)
        MOV        R0, R16
        LDI        R17, HIGH(0x0001)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; SetBit(LED_BL6_A)
        SBI        PORTB, 6
 
; SetBit(Z80_CLK_A)
        LDS        R16, PORTL
        SBR        R16, 0b00000001
        STS        PORTL, R16
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0001)
        MOV        R0, R16
        LDI        R17, HIGH(0x0001)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; FOR TO DO - (global)Byte-INC-Zaehler
        LDS        R17, CLK_COUNTER
        INC        R17
        STS        CLK_COUNTER, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0149
 
; FOR TO DO - Ende
M_FTD_0151:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; SetBit(Z80_RESET_A)
        LDS        R16, PORTL
        SBR        R16, 0b00000100
        STS        PORTL, R16
 
; ClearBit(LED_BL6_A)
        CBI        PORTB, 6
 
; LOOP - Start_Marke
M_LOOP_0152:
 
; WHILE DO ...
M_WHILE_0153:
 
; WHILE - Ausdruck /; BitLow(TASTER_01_E)
        LDS        R16, PINH
        BST        R16, 3
        BRTC       M_VERGL_0156
        CLR        R16
        RJMP       M_VERGL_0157
M_VERGL_0156:
        SER        R16
M_VERGL_0157:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0154
        RJMP       M_WHILE_0155
M_WHILE_0154:
 
; SetBit(LED_BL7_A)
        SBI        PORTB, 7
 
; SetBit(Z80_CLK_A)
        LDS        R16, PORTL
        SBR        R16, 0b00000001
        STS        PORTL, R16
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; WHILE DO ...
        RJMP       M_WHILE_0153
M_WHILE_0155:
 
; Aufruf PROCEDURE (ABFRAGE_MREQ_RD)
        LDI   ZL,byte3(ABFRAGE_MREQ_RD)
        OUT   EIND,ZL
        LDI   ZL,low(ABFRAGE_MREQ_RD)
        LDI   ZH,high(ABFRAGE_MREQ_RD)
        EICALL
 
; WHILE DO ...
M_WHILE_0158:
 
; WHILE - Ausdruck /; BitHigh(TASTER_01_E)
        LDS        R16, PINH
        BST        R16, 3
        BRTS       M_VERGL_0161
        CLR        R16
        RJMP       M_VERGL_0162
M_VERGL_0161:
        SER        R16
M_VERGL_0162:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0159
        RJMP       M_WHILE_0160
M_WHILE_0159:
 
; ClearBit(LED_BL7_A)
        CBI        PORTB, 7
 
; ClearBit(Z80_CLK_A)
        LDS        R16, PORTL
        CBR        R16, 0b00000001
        STS        PORTL, R16
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        LDI   ZL,byte3(WAIT_MS)
        OUT   EIND,ZL
        LDI   ZL,low(WAIT_MS)
        LDI   ZH,high(WAIT_MS)
        EICALL
 
; WHILE DO ...
        RJMP       M_WHILE_0158
M_WHILE_0160:
 
; Aufruf PROCEDURE (ABFRAGE_MREQ_RD)
        LDI   ZL,byte3(ABFRAGE_MREQ_RD)
        OUT   EIND,ZL
        LDI   ZL,low(ABFRAGE_MREQ_RD)
        LDI   ZH,high(ABFRAGE_MREQ_RD)
        EICALL
 
; LOOP - Ende
        RJMP       M_LOOP_0152
 
; *** Unterprogramm Bibliothek ***
; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; UDR1 (V) BYTECONVAR
; UBRR1H (V) BYTECONVAR
; UBRR1L (V) BYTECONVAR
; UCSR1A (V) BYTECONVAR
; UCSR1B (V) BYTECONVAR
; UCSR1C (V) BYTECONVAR
; UDR2 (V) BYTECONVAR
; UBRR2H (V) BYTECONVAR
; UBRR2L (V) BYTECONVAR
; UCSR2A (V) BYTECONVAR
; UCSR2B (V) BYTECONVAR
; UCSR2C (V) BYTECONVAR
; UDR3 (V) BYTECONVAR
; UBRR3H (V) BYTECONVAR
; UBRR3L (V) BYTECONVAR
; UCSR3A (V) BYTECONVAR
; UCSR3B (V) BYTECONVAR
; UCSR3C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1CL (V) BYTECONVAR
; OCR1CH (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; OCR3AL (V) BYTECONVAR
; OCR3AH (V) BYTECONVAR
; OCR3BL (V) BYTECONVAR
; OCR3BH (V) BYTECONVAR
; OCR3CL (V) BYTECONVAR
; OCR3CH (V) BYTECONVAR
; ICR3L (V) BYTECONVAR
; ICR3H (V) BYTECONVAR
; TCNT3L (V) BYTECONVAR
; TCNT3H (V) BYTECONVAR
; TCCR3A (V) BYTECONVAR
; TCCR3B (V) BYTECONVAR
; TCCR3C (V) BYTECONVAR
; OCR4AL (V) BYTECONVAR
; OCR4AH (V) BYTECONVAR
; OCR4BL (V) BYTECONVAR
; OCR4BH (V) BYTECONVAR
; OCR4CL (V) BYTECONVAR
; OCR4CH (V) BYTECONVAR
; ICR4L (V) BYTECONVAR
; ICR4H (V) BYTECONVAR
; TCNT4L (V) BYTECONVAR
; TCNT4H (V) BYTECONVAR
; TCCR4A (V) BYTECONVAR
; TCCR4B (V) BYTECONVAR
; TCCR4C (V) BYTECONVAR
; OCR5AL (V) BYTECONVAR
; OCR5AH (V) BYTECONVAR
; OCR5BL (V) BYTECONVAR
; OCR5BH (V) BYTECONVAR
; OCR5CL (V) BYTECONVAR
; OCR5CH (V) BYTECONVAR
; ICR5L (V) BYTECONVAR
; ICR5H (V) BYTECONVAR
; TCNT5L (V) BYTECONVAR
; TCNT5H (V) BYTECONVAR
; TCCR5A (V) BYTECONVAR
; TCCR5B (V) BYTECONVAR
; TCCR5C (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK3 (V) BYTECONVAR
; TIMSK4 (V) BYTECONVAR
; TIMSK5 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR2 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; EICRB (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; XMCRA (V) BYTECONVAR
; XMCRB (V) BYTECONVAR
; PORTH (V) BYTECONVAR
; DDRH (V) BYTECONVAR
; PINH (V) BYTECONVAR
; PORTJ (V) BYTECONVAR
; DDRJ (V) BYTECONVAR
; PINJ (V) BYTECONVAR
; PORTK (V) BYTECONVAR
; DDRK (V) BYTECONVAR
; PINK (V) BYTECONVAR
; PORTL (V) BYTECONVAR
; DDRL (V) BYTECONVAR
; PINL (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; PRR1 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR3 (V) BYTECONREG
; TIFR4 (V) BYTECONREG
; TIFR5 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; PORTE (V) BYTECONREG
; DDRE (V) BYTECONREG
; PINE (V) BYTECONREG
; PORTF (V) BYTECONREG
; DDRF (V) BYTECONREG
; PINF (V) BYTECONREG
; PORTG (V) BYTECONREG
; DDRG (V) BYTECONREG
; PING (V) BYTECONREG
; RAMPZ (V) BYTECONREG
; EIND (V) BYTECONREG
; TAKTFREQUENZ (C) WORD Wert=0x3E80
; UBRR_VAL (C) BYTE Wert=0x05
; Z80_M1_A (B) BIT
; Z80_M1_E (B) BIT
; Z80_M1_D (B) BIT
; Z80_MREQ_A (B) BIT
; Z80_MREQ_E (B) BIT
; Z80_MREQ_D (B) BIT
; Z80_IORQ_A (B) BIT
; Z80_IORQ_E (B) BIT
; Z80_IORQ_D (B) BIT
; Z80_RD_A (B) BIT
; Z80_RD_E (B) BIT
; Z80_RD_D (B) BIT
; Z80_WR_A (B) BIT
; Z80_WR_E (B) BIT
; Z80_WR_D (B) BIT
; Z80_RFSH_A (B) BIT
; Z80_RFSH_E (B) BIT
; Z80_RFSH_D (B) BIT
; Z80_HALT_A (B) BIT
; Z80_HALT_E (B) BIT
; Z80_HALT_D (B) BIT
; Z80_BUSACK_A (B) BIT
; Z80_BUSACK_E (B) BIT
; Z80_BUSACK_D (B) BIT
; Z80_CLK_A (B) BIT
; Z80_CLK_E (B) BIT
; Z80_CLK_D (B) BIT
; Z80_RESET_A (B) BIT
; Z80_RESET_E (B) BIT
; Z80_RESET_D (B) BIT
; Z80_WAIT_A (B) BIT
; Z80_WAIT_E (B) BIT
; Z80_WAIT_D (B) BIT
; Z80_NMI_A (B) BIT
; Z80_NMI_E (B) BIT
; Z80_NMI_D (B) BIT
; Z80_INT_A (B) BIT
; Z80_INT_E (B) BIT
; Z80_INT_D (B) BIT
; Z80_BUSRQ_A (B) BIT
; Z80_BUSRQ_E (B) BIT
; Z80_BUSRQ_D (B) BIT
; RAM_WE_A (B) BIT
; RAM_WE_E (B) BIT
; RAM_WE_D (B) BIT
; RAM_RD_A (B) BIT
; RAM_RD_E (B) BIT
; RAM_RD_D (B) BIT
; RAM_CE_A (B) BIT
; RAM_CE_E (B) BIT
; RAM_CE_D (B) BIT
; LED_BL3_A (B) BIT
; LED_BL3_D (B) BIT
; LED_BL4_A (B) BIT
; LED_BL4_D (B) BIT
; LED_BL5_A (B) BIT
; LED_BL5_D (B) BIT
; LED_BL6_A (B) BIT
; LED_BL6_D (B) BIT
; LED_BL7_D (B) BIT
; LED_BL7_A (B) BIT
; TASTER_01_D (B) BIT
; TASTER_01_E (B) BIT
; TASTER_02_D (B) BIT
; TASTER_02_E (B) BIT
; TASTER_03_D (B) BIT
; TASTER_03_E (B) BIT
; CLK_COUNTER (V) BYTE
; RAM_READ_AKTIV (V) BOOLEAN
; WAITKON (C) WORD Wert=0x0010
; WAITKON2 (C) WORD Wert=0x02D0
; BYTE_HEX_STRING (V) STRING
; BYTE_DEZ_STRING (V) STRING
; WORD_HEX_STRING (V) STRING
; DWORD_HEX_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; NEGATION_BYTE (F) 
; WAIT_MS (P) 
; BYTETOHEXSTRING (P) 
; BYTETODEZSTRING (P) 
; HEXSTRINGTOBYTE (F) 
; WORDTOHEXSTRING (P) 
; HEXSTRINGTOWORD (F) 
; DWORDTOHEXSTRING (P) 
; RAM_ARRAY (Y) BYTE
; INIT_RAM (P) 
; LESE_RAM (F) 
; INITPORTS (P) 
; RAM_READ_EINSCHALTEN (P) 
; RAM_READ_AUSSCHALTEN (P) 
; ABFRAGE_MREQ_RD (P) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION NEGATION_BYTE (DAS_BYTE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOHEXSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; PROCEDURE BYTETODEZSTRING (WERT_BYTE : BYTE) (B1 : BYTE) (B2 : BYTE) (C1 : CHAR);
; FUNCTION HEXSTRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE WORDTOHEXSTRING (WERT_WORD : WORD) (BYTE_LOW : BYTE) (BYTE_HIGH : BYTE);
; FUNCTION HEXSTRINGTOWORD (C1 : CHAR) (S2W : WORD) (S2B : BYTE) (S2W2 : WORD) : WORD;
; PROCEDURE DWORDTOHEXSTRING (WERT_DWORD : DWORD) (WORD_LOW : WORD) (WORD_HIGH : WORD);
; PROCEDURE INIT_RAM;
; FUNCTION LESE_RAM (DATEN_BYTE : BYTE) (ADRESS_BYTE : BYTE) (ADRESS_WORD : WORD) (ADRESS_WORD_LOW : WORD) : BYTE;
; PROCEDURE INITPORTS;
; PROCEDURE RAM_READ_EINSCHALTEN (DATA_BYTE : BYTE);
; PROCEDURE RAM_READ_AUSSCHALTEN;
; PROCEDURE ABFRAGE_MREQ_RD;
 
